// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: data/v0alpha/bytevault.proto

package v0alphaconnect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v0alpha "gitlab.com/sourcehaven/mypass/go.datastore/v0-alpha/internal/proto/data/v0alpha"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// ByteVaultServiceName is the fully-qualified name of the ByteVaultService service.
	ByteVaultServiceName = "data.v0alpha.ByteVaultService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// ByteVaultServiceSyncProcedure is the fully-qualified name of the ByteVaultService's Sync RPC.
	ByteVaultServiceSyncProcedure = "/data.v0alpha.ByteVaultService/Sync"
	// ByteVaultServiceFetchProcedure is the fully-qualified name of the ByteVaultService's Fetch RPC.
	ByteVaultServiceFetchProcedure = "/data.v0alpha.ByteVaultService/Fetch"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	byteVaultServiceServiceDescriptor     = v0alpha.File_data_v0alpha_bytevault_proto.Services().ByName("ByteVaultService")
	byteVaultServiceSyncMethodDescriptor  = byteVaultServiceServiceDescriptor.Methods().ByName("Sync")
	byteVaultServiceFetchMethodDescriptor = byteVaultServiceServiceDescriptor.Methods().ByName("Fetch")
)

// ByteVaultServiceClient is a client for the data.v0alpha.ByteVaultService service.
type ByteVaultServiceClient interface {
	// Sync synchronizes or creates byte vault with datastore. If vault does not exists yet,
	// then it will be created on the data-storage server, otherwise - if possible - this
	// vault will be synchronized with the corresponding request.
	Sync(context.Context, *connect.Request[v0alpha.SyncRequest]) (*connect.Response[emptypb.Empty], error)
	// Fetch fetches vault data from datastore. Every. Last. Byte.
	Fetch(context.Context, *connect.Request[v0alpha.FetchRequest]) (*connect.Response[v0alpha.FetchResponse], error)
}

// NewByteVaultServiceClient constructs a client for the data.v0alpha.ByteVaultService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewByteVaultServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) ByteVaultServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &byteVaultServiceClient{
		sync: connect.NewClient[v0alpha.SyncRequest, emptypb.Empty](
			httpClient,
			baseURL+ByteVaultServiceSyncProcedure,
			connect.WithSchema(byteVaultServiceSyncMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		fetch: connect.NewClient[v0alpha.FetchRequest, v0alpha.FetchResponse](
			httpClient,
			baseURL+ByteVaultServiceFetchProcedure,
			connect.WithSchema(byteVaultServiceFetchMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// byteVaultServiceClient implements ByteVaultServiceClient.
type byteVaultServiceClient struct {
	sync  *connect.Client[v0alpha.SyncRequest, emptypb.Empty]
	fetch *connect.Client[v0alpha.FetchRequest, v0alpha.FetchResponse]
}

// Sync calls data.v0alpha.ByteVaultService.Sync.
func (c *byteVaultServiceClient) Sync(ctx context.Context, req *connect.Request[v0alpha.SyncRequest]) (*connect.Response[emptypb.Empty], error) {
	return c.sync.CallUnary(ctx, req)
}

// Fetch calls data.v0alpha.ByteVaultService.Fetch.
func (c *byteVaultServiceClient) Fetch(ctx context.Context, req *connect.Request[v0alpha.FetchRequest]) (*connect.Response[v0alpha.FetchResponse], error) {
	return c.fetch.CallUnary(ctx, req)
}

// ByteVaultServiceHandler is an implementation of the data.v0alpha.ByteVaultService service.
type ByteVaultServiceHandler interface {
	// Sync synchronizes or creates byte vault with datastore. If vault does not exists yet,
	// then it will be created on the data-storage server, otherwise - if possible - this
	// vault will be synchronized with the corresponding request.
	Sync(context.Context, *connect.Request[v0alpha.SyncRequest]) (*connect.Response[emptypb.Empty], error)
	// Fetch fetches vault data from datastore. Every. Last. Byte.
	Fetch(context.Context, *connect.Request[v0alpha.FetchRequest]) (*connect.Response[v0alpha.FetchResponse], error)
}

// NewByteVaultServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewByteVaultServiceHandler(svc ByteVaultServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	byteVaultServiceSyncHandler := connect.NewUnaryHandler(
		ByteVaultServiceSyncProcedure,
		svc.Sync,
		connect.WithSchema(byteVaultServiceSyncMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	byteVaultServiceFetchHandler := connect.NewUnaryHandler(
		ByteVaultServiceFetchProcedure,
		svc.Fetch,
		connect.WithSchema(byteVaultServiceFetchMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/data.v0alpha.ByteVaultService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case ByteVaultServiceSyncProcedure:
			byteVaultServiceSyncHandler.ServeHTTP(w, r)
		case ByteVaultServiceFetchProcedure:
			byteVaultServiceFetchHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedByteVaultServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedByteVaultServiceHandler struct{}

func (UnimplementedByteVaultServiceHandler) Sync(context.Context, *connect.Request[v0alpha.SyncRequest]) (*connect.Response[emptypb.Empty], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("data.v0alpha.ByteVaultService.Sync is not implemented"))
}

func (UnimplementedByteVaultServiceHandler) Fetch(context.Context, *connect.Request[v0alpha.FetchRequest]) (*connect.Response[v0alpha.FetchResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("data.v0alpha.ByteVaultService.Fetch is not implemented"))
}
